Subject: Re: __git_ignore_line positional argument (un)escaping (was: Re: _git-reset doesn't complete newly staged files)
From: "Jun T." <[email-masked]>
To: "[email-masked]" <[email-masked]>
Date: Fri, 11 Mar 2016 17:24:02 +0900
List-Id: Zsh Workers List <zsh-workers.zsh.org>

On 2016/03/11, at 8:20, Daniel Shahaf <[email-masked]> wrote:
> 
> With just ${(Q)line[...}}, you lose the ability to distinguish «git add
> f\[a-z\]o <TAB>» from «git add f[a-z]o <TAB>».
(snip)

With the following style:
zstyle ':completion:*:*:ls:*' ignore-line true               

With the current git HEAD:
[1]% touch foo 'f[a-z]o' '[f]oo'
[2]% ls f\[a-z\]o <TAB>      # OK: f\[a-z\]o not offered
[3]% git add f\[a-z\] <TAB>  # no: f\[a-z\]o is offered again
[4]% ls f[a-z]o <TAB>        # no: foo is offered
[5]% git add f[a-z]o <TAB>   # no: foo is offered

With ${(bQ)..} in __git_ignore_line and _description:
[6]% ls f\[a-z\]o <TAB>      # no: f\[a-z\]o is offered again
[7]% git add f\[a-z\] <TAB>  # OK: f\[a-z\]o is not offered
[8]% ls f[a-z]o <TAB>        # OK: foo is not offered
[9]% git add f[a-z]o <TAB>   # OK: foo is not offered

I don't know why the behavior is different between ls and git add
in the first two cases ([2][3]/[6][7]), because _description and
 __git_ignore_line uses virtually the same escaping method.

> 2. The ignore-line currently uses the following escaping:
> .
>   # Completion/Base/Core/_description
>   50	  if zstyle -s ":completion:${curcontext}:$1" ignore-line hidden; then
>   51	    local -a qwords
>   52	    qwords=( ${words//(#m)[\[\]()\\*?#<>~\^\|]/\\$MATCH} )
> .
> Should the ignore-line style use ${(bQ)}?

I've copied the line from _rm about two years ago; see workers/32435.
I don't remember the detail (sorry), but it seems I tried to escape
only the characters which are already escaped on the command line so
that a bare (active, unescaped) * etc can go into _comp_ignore and
% ls f* <TAB>
does not offer foo etc. But I abandoned this method because patterns
with qualifier caused a problem like:

% touch foo          # foo does not have execution permission
% ls f*(x) <TAB>     # foo is NOT offered

With (bQ), this does't happen, but now (as in [6] above):

% touch 'a[b]c' 'd<e>f' 'g(h)i'
% ls a\[b\]c d\<e\>f g\(h\)i <TAB>  # all the files are still offered

This doesn't happen with the current HEAD. I don't know which is
better; maybe patterns like f* are frequently used but strange
file names like 'a[b]c' rarely happen, so using (bQ) is somewhat
better...? And I don't understand why ls and 'git add' behaves
differently.

On 2016/03/10, at 23:35, Mikael Magnusson <[email-masked]> wrote:

> Why does _git special case this at all, isn't the generic ignore-line
> mechanism for the git-add context good enough?

I have no idea why. I just assumed there was a reason to do that.

It would be better to use generic ignore-line if possible, of course.
If I have
zstyle ':completion:*:*:(^rm):*:*files' ignored-patterns '*?.o' '*?.old'
then '-F _comp_ignore' is passed to compadd, and the '-F ignored' added
by __git_ignroe_line has no effect. Of course I can use
zstyle ':completion:*:*:(^(rm|git*)):*:*files' ...
but ...

Sorry I fear I will not be able to reply for several days or so.